/* Generated by wayland-scanner 1.22.0 */

#ifndef GAMESCOPE_COMMIT_QUEUE_V1_CLIENT_PROTOCOL_H
#define GAMESCOPE_COMMIT_QUEUE_V1_CLIENT_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-client.h"

#ifdef  __cplusplus
extern "C" {
#endif

/**
 * @page page_gamescope_commit_queue_v1 The gamescope_commit_queue_v1 protocol
 * @section page_ifaces_gamescope_commit_queue_v1 Interfaces
 * - @subpage page_iface_gamescope_commit_queue_manager_v1 - commit queuing
 * - @subpage page_iface_gamescope_commit_queue_v1 - commit queue controller
 * @section page_copyright_gamescope_commit_queue_v1 Copyright
 * <pre>
 *
 * Copyright © 2023 Valve Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 * </pre>
 */
struct gamescope_commit_queue_manager_v1;
struct gamescope_commit_queue_v1;
struct wl_surface;

#ifndef GAMESCOPE_COMMIT_QUEUE_MANAGER_V1_INTERFACE
#define GAMESCOPE_COMMIT_QUEUE_MANAGER_V1_INTERFACE
/**
 * @page page_iface_gamescope_commit_queue_manager_v1 gamescope_commit_queue_manager_v1
 * @section page_iface_gamescope_commit_queue_manager_v1_desc Description
 *
 * By design Wayland uses a "mailbox" style presentation model. Under
 * the mailbox model, when wl_surface.commit is called, the currently
 * pending state is intended to replace the current state immediately.
 *
 * If state is committed many times before the compositor repaints a
 * scene, each commit takes place immediately, updating the existing
 * state. When the compositor repaints the display only the most
 * recent accumulation of state is visible. This may lead to client
 * buffers being released without presentation if they were replaced
 * before being displayed.
 *
 * There are other presentation models such as FIFO (First In First
 * Out) in which state commits are explicitly queued for future
 * repaint intervals, and client buffers should not be released
 * without being displayed.
 *
 * Graphics APIs such as Vulkan aim to support these presentation
 * models, but they are not implementable on top of our mailbox model
 * without the ability to change the default surface state handling
 * behaviour.
 *
 * This interface provides a way to control the compositor's surface
 * state handling to enable presentation models other than mailbox.
 *
 * It does so by exposing control of a compositor surface state queue,
 * and specifying for each call of wl_surface.commit whether the
 * pending state should be handled in a mailbox or a FIFO fashion.
 *
 * Warning! The protocol described in this file is currently in the testing
 * phase. Backward compatible changes may be added together with the
 * corresponding interface version bump. Backward incompatible changes can
 * only be done by creating a new major version of the extension.
 * @section page_iface_gamescope_commit_queue_manager_v1_api API
 * See @ref iface_gamescope_commit_queue_manager_v1.
 */
/**
 * @defgroup iface_gamescope_commit_queue_manager_v1 The gamescope_commit_queue_manager_v1 interface
 *
 * By design Wayland uses a "mailbox" style presentation model. Under
 * the mailbox model, when wl_surface.commit is called, the currently
 * pending state is intended to replace the current state immediately.
 *
 * If state is committed many times before the compositor repaints a
 * scene, each commit takes place immediately, updating the existing
 * state. When the compositor repaints the display only the most
 * recent accumulation of state is visible. This may lead to client
 * buffers being released without presentation if they were replaced
 * before being displayed.
 *
 * There are other presentation models such as FIFO (First In First
 * Out) in which state commits are explicitly queued for future
 * repaint intervals, and client buffers should not be released
 * without being displayed.
 *
 * Graphics APIs such as Vulkan aim to support these presentation
 * models, but they are not implementable on top of our mailbox model
 * without the ability to change the default surface state handling
 * behaviour.
 *
 * This interface provides a way to control the compositor's surface
 * state handling to enable presentation models other than mailbox.
 *
 * It does so by exposing control of a compositor surface state queue,
 * and specifying for each call of wl_surface.commit whether the
 * pending state should be handled in a mailbox or a FIFO fashion.
 *
 * Warning! The protocol described in this file is currently in the testing
 * phase. Backward compatible changes may be added together with the
 * corresponding interface version bump. Backward incompatible changes can
 * only be done by creating a new major version of the extension.
 */
extern const struct wl_interface gamescope_commit_queue_manager_v1_interface;
#endif
#ifndef GAMESCOPE_COMMIT_QUEUE_V1_INTERFACE
#define GAMESCOPE_COMMIT_QUEUE_V1_INTERFACE
/**
 * @page page_iface_gamescope_commit_queue_v1 gamescope_commit_queue_v1
 * @section page_iface_gamescope_commit_queue_v1_desc Description
 *
 * A queue controller for a surface.
 *
 * A wayland compositor may implicitly queue surface state to
 * allow it to pick the most recently ready state at repaint time,
 * or to allow surface state to contain timing information.
 *
 * The commit queue controller object allows explicit control over
 * the queue of upcoming surface state by allowing a client to attach
 * a queue drain mode to pending surface state before it calls
 * wl_surface.commit.
 * @section page_iface_gamescope_commit_queue_v1_api API
 * See @ref iface_gamescope_commit_queue_v1.
 */
/**
 * @defgroup iface_gamescope_commit_queue_v1 The gamescope_commit_queue_v1 interface
 *
 * A queue controller for a surface.
 *
 * A wayland compositor may implicitly queue surface state to
 * allow it to pick the most recently ready state at repaint time,
 * or to allow surface state to contain timing information.
 *
 * The commit queue controller object allows explicit control over
 * the queue of upcoming surface state by allowing a client to attach
 * a queue drain mode to pending surface state before it calls
 * wl_surface.commit.
 */
extern const struct wl_interface gamescope_commit_queue_v1_interface;
#endif

#ifndef GAMESCOPE_COMMIT_QUEUE_MANAGER_V1_ERROR_ENUM
#define GAMESCOPE_COMMIT_QUEUE_MANAGER_V1_ERROR_ENUM
/**
 * @ingroup iface_gamescope_commit_queue_manager_v1
 * fatal presentation error
 *
 * These fatal protocol errors may be emitted in response to
 * illegal requests.
 */
enum gamescope_commit_queue_manager_v1_error {
	/**
	 * commit queue controller already exists for surface
	 */
	GAMESCOPE_COMMIT_QUEUE_MANAGER_V1_ERROR_QUEUE_CONTROLLER_ALREADY_EXISTS = 0,
};
#endif /* GAMESCOPE_COMMIT_QUEUE_MANAGER_V1_ERROR_ENUM */

#define GAMESCOPE_COMMIT_QUEUE_MANAGER_V1_DESTROY 0
#define GAMESCOPE_COMMIT_QUEUE_MANAGER_V1_GET_QUEUE_CONTROLLER 1


/**
 * @ingroup iface_gamescope_commit_queue_manager_v1
 */
#define GAMESCOPE_COMMIT_QUEUE_MANAGER_V1_DESTROY_SINCE_VERSION 1
/**
 * @ingroup iface_gamescope_commit_queue_manager_v1
 */
#define GAMESCOPE_COMMIT_QUEUE_MANAGER_V1_GET_QUEUE_CONTROLLER_SINCE_VERSION 1

/** @ingroup iface_gamescope_commit_queue_manager_v1 */
static inline void
gamescope_commit_queue_manager_v1_set_user_data(struct gamescope_commit_queue_manager_v1 *gamescope_commit_queue_manager_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) gamescope_commit_queue_manager_v1, user_data);
}

/** @ingroup iface_gamescope_commit_queue_manager_v1 */
static inline void *
gamescope_commit_queue_manager_v1_get_user_data(struct gamescope_commit_queue_manager_v1 *gamescope_commit_queue_manager_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) gamescope_commit_queue_manager_v1);
}

static inline uint32_t
gamescope_commit_queue_manager_v1_get_version(struct gamescope_commit_queue_manager_v1 *gamescope_commit_queue_manager_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) gamescope_commit_queue_manager_v1);
}

/**
 * @ingroup iface_gamescope_commit_queue_manager_v1
 *
 * Informs the server that the client will no longer be using
 * this protocol object. Existing objects created by this object
 * are not affected.
 */
static inline void
gamescope_commit_queue_manager_v1_destroy(struct gamescope_commit_queue_manager_v1 *gamescope_commit_queue_manager_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) gamescope_commit_queue_manager_v1,
			 GAMESCOPE_COMMIT_QUEUE_MANAGER_V1_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) gamescope_commit_queue_manager_v1), WL_MARSHAL_FLAG_DESTROY);
}

/**
 * @ingroup iface_gamescope_commit_queue_manager_v1
 *
 * Establish a queue controller for a surface.
 *
 * Graphics APIs (EGL, Vulkan) will likely use this protocol
 * internally, so clients using them shouldn't directly use this
 * protocol on surfaces managed by those APIs, or a
 * queue_controller_already_exists protocol error will occur.
 */
static inline struct gamescope_commit_queue_v1 *
gamescope_commit_queue_manager_v1_get_queue_controller(struct gamescope_commit_queue_manager_v1 *gamescope_commit_queue_manager_v1, struct wl_surface *surface)
{
	struct wl_proxy *id;

	id = wl_proxy_marshal_flags((struct wl_proxy *) gamescope_commit_queue_manager_v1,
			 GAMESCOPE_COMMIT_QUEUE_MANAGER_V1_GET_QUEUE_CONTROLLER, &gamescope_commit_queue_v1_interface, wl_proxy_get_version((struct wl_proxy *) gamescope_commit_queue_manager_v1), 0, NULL, surface);

	return (struct gamescope_commit_queue_v1 *) id;
}

#ifndef GAMESCOPE_COMMIT_QUEUE_V1_ERROR_ENUM
#define GAMESCOPE_COMMIT_QUEUE_V1_ERROR_ENUM
/**
 * @ingroup iface_gamescope_commit_queue_v1
 * fatal presentation error
 *
 * These fatal protocol errors may be emitted in response to
 * illegal requests.
 */
enum gamescope_commit_queue_v1_error {
	/**
	 * invalid queue mode
	 */
	GAMESCOPE_COMMIT_QUEUE_V1_ERROR_INVALID_QUEUE_MODE = 0,
};
#endif /* GAMESCOPE_COMMIT_QUEUE_V1_ERROR_ENUM */

#ifndef GAMESCOPE_COMMIT_QUEUE_V1_QUEUE_MODE_ENUM
#define GAMESCOPE_COMMIT_QUEUE_V1_QUEUE_MODE_ENUM
/**
 * @ingroup iface_gamescope_commit_queue_v1
 * Queue drain mode
 *
 * This enum is used to choose how the compositor processes a queue
 * entry at output repaint time.
 */
enum gamescope_commit_queue_v1_queue_mode {
	/**
	 * Fast forward through past timestamps
	 *
	 * State from this queue slot may be updated immediately (without
	 * completing a repaint) if newer state is ready to display at
	 * repaint time.
	 */
	GAMESCOPE_COMMIT_QUEUE_V1_QUEUE_MODE_MAILBOX = 0,
	/**
	 * Attempt to display each queued commit
	 *
	 * This queue slot will be the last state update for this surface
	 * that the compositor will process during the repaint in which it
	 * is ready for display.
	 *
	 * If the compositor is presenting with tearing, the surface state
	 * must be made current for an iteration of the compositor's
	 * repaint loop. This may result in the state being visible for a
	 * very short duration, with visible artifacts, or even not visible
	 * at all for surfaces that aren't full screen.
	 *
	 * The compositor must not cause state processing to stall
	 * indefinitely for a surface that is occluded or otherwise not
	 * visible. Instead, if the compositor is choosing not to present a
	 * surface for reasons unrelated to state readiness, the FIFO
	 * condition must be considered satisfied at the moment new state
	 * becomes ready to replace the undisplayed state.
	 */
	GAMESCOPE_COMMIT_QUEUE_V1_QUEUE_MODE_FIFO = 1,
};
#endif /* GAMESCOPE_COMMIT_QUEUE_V1_QUEUE_MODE_ENUM */

#define GAMESCOPE_COMMIT_QUEUE_V1_SET_QUEUE_MODE 0
#define GAMESCOPE_COMMIT_QUEUE_V1_DESTROY 1


/**
 * @ingroup iface_gamescope_commit_queue_v1
 */
#define GAMESCOPE_COMMIT_QUEUE_V1_SET_QUEUE_MODE_SINCE_VERSION 1
/**
 * @ingroup iface_gamescope_commit_queue_v1
 */
#define GAMESCOPE_COMMIT_QUEUE_V1_DESTROY_SINCE_VERSION 1

/** @ingroup iface_gamescope_commit_queue_v1 */
static inline void
gamescope_commit_queue_v1_set_user_data(struct gamescope_commit_queue_v1 *gamescope_commit_queue_v1, void *user_data)
{
	wl_proxy_set_user_data((struct wl_proxy *) gamescope_commit_queue_v1, user_data);
}

/** @ingroup iface_gamescope_commit_queue_v1 */
static inline void *
gamescope_commit_queue_v1_get_user_data(struct gamescope_commit_queue_v1 *gamescope_commit_queue_v1)
{
	return wl_proxy_get_user_data((struct wl_proxy *) gamescope_commit_queue_v1);
}

static inline uint32_t
gamescope_commit_queue_v1_get_version(struct gamescope_commit_queue_v1 *gamescope_commit_queue_v1)
{
	return wl_proxy_get_version((struct wl_proxy *) gamescope_commit_queue_v1);
}

/**
 * @ingroup iface_gamescope_commit_queue_v1
 *
 * This request adds a queue drain mode to the pending surface
 * state, which will be commit by the next wl_surface.commit.
 *
 * This request tells the compositor how to process the state
 * from that commit when handling its internal state queue.
 *
 * If the drain mode is "mailbox", the compositor may continue
 * processing the next state in the queue before it repaints
 * the display.
 *
 * If the drain mode is "fifo", the compositor should ensure the
 * queue is not advanced until after this state has been current
 * for a repaint. The queue may be advance without repaint in the
 * case of off-screen or occluded surfaces.
 *
 * The default drain mode when none is specified is "mailbox".
 */
static inline void
gamescope_commit_queue_v1_set_queue_mode(struct gamescope_commit_queue_v1 *gamescope_commit_queue_v1, uint32_t mode)
{
	wl_proxy_marshal_flags((struct wl_proxy *) gamescope_commit_queue_v1,
			 GAMESCOPE_COMMIT_QUEUE_V1_SET_QUEUE_MODE, NULL, wl_proxy_get_version((struct wl_proxy *) gamescope_commit_queue_v1), 0, mode);
}

/**
 * @ingroup iface_gamescope_commit_queue_v1
 *
 * Informs the server that the client will no longer be using
 * this protocol object.
 *
 * Surface state changes previously made by this protocol are
 * unaffected by this object's destruction.
 */
static inline void
gamescope_commit_queue_v1_destroy(struct gamescope_commit_queue_v1 *gamescope_commit_queue_v1)
{
	wl_proxy_marshal_flags((struct wl_proxy *) gamescope_commit_queue_v1,
			 GAMESCOPE_COMMIT_QUEUE_V1_DESTROY, NULL, wl_proxy_get_version((struct wl_proxy *) gamescope_commit_queue_v1), WL_MARSHAL_FLAG_DESTROY);
}

#ifdef  __cplusplus
}
#endif

#endif
